#ifndef __R128_VIDEO_H__
#define __R128_VIDEO_H__

typedef struct _PortPrivRec {
    struct _AdaptorPrivRec *    pAdaptor;
    I2CBusPtr			pI2CBus;
    I2CDevRec                   I2CDev; 

    FBAreaPtr			pFBArea[2];
    int				Buffers;
    long			buf_offset[2];
    Bool			buffers_allocated;
    
    CARD16			vert_inc;
    CARD16			horz_inc;

    CARD32			scale_cntl;
    CARD32			video_format;
    CARD32			auto_flip_cntl;
    CARD32			overlay_key;
    CARD8			overlay_pixel_size;
    CARD8			current_buffer;
    int				overlay_pad;
    CARD32			overlay_id;
    CARD32			overlay_width;
    CARD32			overlay_height;
    CARD32			BufferBase[3];		/* x1 */
    CARD32			BufferStride;		/* x1 */

    CARD32			drw_w,drw_h;
    
    RegionRec			prev_cliplist;
    Bool			first_put_video;
    
    CARD8			paint_cliplist;
    
    CARD32			save_off_pitch,save_h_total_disp,save_v_total_disp;

    INT32			vx, vy, vw, vh;		/* 12.10 fp; int */
    int				dx, dy, dw, dh;
    int				fw, fh;
    int				APO;
    int				FramesPerSec, FrameAcc;
    int				BkgCol;			/* RGB 5:6:5;5:6:5 */
    int				VideoOn;		/* No, Once, Yes */
    Bool			StreamOn;
    
    int			theatre_num;	/* which device is rage theatre chip */
    CARD32		wStandard;
    CARD32		wConnector;
    int			iHue;
    int			iSaturation;
    CARD32		wSaturation_U;
    CARD32		wSaturation_V;
    int			iBrightness;
    int			dbBrightnessRatio;
    int			dbContrast;
    CARD32		wSharpness;
    int			iContrast;
    CARD32		wInterlaced;
    CARD32		wTunerConnector;
    CARD32		wComp0Connector;
    CARD32		wSVideo0Connector;
    CARD32		dwHorzScalingRatio;
    CARD32		dwVertScalingRatio;
    CARD16		video_decoder_type;
    Bool		capture_on;
    int			encoding;
    	/* i2c bus timing parameters */
    int			r128_time;
    int			r128_N;
    int			r128_M;
    
    CARD8		tuner_addr;
    
    int			volume;
    CARD8		mute;
    
    CARD8		msp3430_addr;
    
    CARD8		bt829_addr;
    CARD8		bt829_id;
    CARD8		bt829_vpole;
    CARD16		bt829_adelay;
    CARD16		bt829_bdelay;
    CARD16		bt829_hdelay;
    CARD16		bt829_vdelay;
    CARD16		bt829_luma;
    CARD16		bt829_sat_u;
    CARD16		bt829_sat_v;
    int			bt829_xtsel;
    int			bt829_htotal;
    int			bt829_vtotal;
    int			bt829_ldec;
    int			bt829_cbsense;
    int			bt829_format;
    int			bt829_mux;
    int 		CCmode;
    
    CARD8		tda9850;
    CARD8		stereo;
    CARD8		sap;
} PortPrivRec, *PortPrivPtr;

typedef struct _AdaptorPrivRec {
    struct _AdaptorPrivRec *	Next;
    ScrnInfoPtr			pScrn;
    int				hw_type;  /* hardware type */    
    PortPrivRec                 Port[2]; 
} AdaptorPrivRec, *AdaptorPrivPtr;

#define HW_UNSUPPORTED	0
#define HW_MACH64	1
#define HW_RAGEPRO	2
#define HW_R128		3
#define HW_R128PRO	4


void R128VideoUninit(ScrnInfoPtr pScrn);
void R128VideoReset(ScrnInfoPtr pScrn);
void R128VideoInit(ScreenPtr pScreen);
#define inm(_r)   (INREG(_r))
#define inm8(_r)   (INREG((_r)))
#define outm(_r,_v)	(OUTREG((_r),(_v)))
#define outm8(_r,_v)	(OUTREG8((_r),(_v)))


#endif
