#!/bin/sh
#
# script to generate API docs for a module
#

LINUX_SOURCE=/usr/src/linux
OUTPUT=api.sgml

# process options
while [ "$1" != "" ]; do
	case $1 in
	 -s)	shift
		LINUX_SOURCE=$1
		;;
	 -o)	shift
		OUTPUT=$1
		;;
	  *)	FILES="$FILES $1"
	esac
	shift
done

if [ "$FILES" = "" ]; then
	echo "Usage: $0 [-s linuxsrcdir] [-o outputname] <files to process>"
	exit 1
fi

if [ -f $LINUX_SOURCE/scripts/kernel-doc ] ; then
    $LINUX_SOURCE/scripts/kernel-doc -docbook $FILES > $OUTPUT
else
    echo "kernel-doc utility not found: unable to build documentation"
    echo "please upgrade to a newer kernel"
fi

