#ifndef _MGADVD_PRIV_H
#define _MGADVD_PRIV_H

/* define this if you want to use the interrupt handler
   to send the bitstream to the decoder (default) */
#define USE_INTERRUPTS
/* define this if you have a Rainbow Runner */
/* #define RRG_TRICK(a) (a ^ 0x07) */
#undef RRG_TRICK
/* define this to provide hardware CSS support
   (not functionnal at this time) */
#undef CSS_SUPPORT


#include <linux/version.h>
#include <linux/delay.h>
#include <linux/errno.h>
#include <linux/mm.h>
#include <linux/tqueue.h>                                                       
#include <asm/io.h>
#include <linux/sched.h>
#ifdef CSS_SUPPORT
#include <linux/cdrom.h>
#endif

#include "mgadvd.h"

extern int debug;
#define dprintk     if (debug) printk

#define BITSTREAM_BLOCK_SIZE	2048

#ifndef ZR_BITSTREAM
#define ZR_BITSTREAM 4
#endif


/* function prototypes */
int i34_video_standard(int standard);
int i34_detect(void *codec_interface);
int i34_change_video_sid(int sid);
int i34_change_audio_sid(int sid);
int i34_change_subpic_sid(int sid);
int i34_video_sync(int);
int i34_audio_sync(int);
int i34_dvp_boot(int);
int i34_adp_boot(int);
int i34_select_bitstream(int bs);
u16 i34_read(u8 reg);
int i34_init(void);
int i34_enable_interrupts(int interrupts);
int i34_start(void);
int i34_stop(void);
int i34_pause(void);
int i34_continue(void);
int i34_status(struct mgadvd_status_s *status);

#endif /* _MGADVD_PRIV_H */
