/*
  GPL Driver for the Codec Interface on MGA G1/2/400 cards
  (requires mgacore.c)

  (c) 1999-2000 David Barth <dbarth@besancon.net>
*/

#define CODEC_BUFFER_SIZE	0x40000	/* 256K */
/* #define CODEC_BUFFER_SIZE	0x20000 */	/* 128K */

#define  MGACODEC_MODE_I33	2
#define  MGACODEC_MODE_VMI_A	0
#define  MGACODEC_MODE_VMI_B	16

void mgacodec_init		(struct mga_dev_s *mga, u32 addr, int mode, int reg);
void mgacodec_reset		(struct mga_codec_s *codec);
void mgacodec_and_or_miscctl	(struct mga_codec_s *codec, u8 and, u8 or);
int  mgacodec_set_misc2		(struct mga_codec_s *codec, u8 param);
int  mgacodec_set_ddc2		(struct mga_codec_s *codec, u8 param);
void mgacodec_push_readb	(struct mga_codec_s *codec, u8 reg);
void mgacodec_push_readw	(struct mga_codec_s *codec, u8 reg);
void mgacodec_push_writeb	(struct mga_codec_s *codec, u8 reg, u8 data);
void mgacodec_push_writew	(struct mga_codec_s *codec, u8 reg, u16 data);
void mgacodec_push_pause        (struct mga_codec_s *codec);
int  mgacodec_exec_commands	(struct mga_codec_s *codec);
u8   mgacodec_get_byte		(struct mga_codec_s *codec);
u16  mgacodec_get_word		(struct mga_codec_s *codec);
int  mgacodec_stop_transfer	(struct mga_codec_s *codec);
int  mgacodec_send_bitstream	(struct mga_codec_s *codec, const u8 *bitstream, unsigned int size);


