/***************************************************************************
                          buffer.h  -  description
                             -------------------
    begin                : Tue Dec 7 1999
    copyright            : (C) 1999 by Jeff Anderson
    email                : jbanders@mines.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <fstream.h>

#ifndef MPEG2ENC_H
#define MPEG2ENC_H
#include "mpeg2enc.h"
#endif

#ifndef STATS_H
# define STATS_H
#include "stats.h"
#endif

class IBUFF
{
  public:
	IBUFF();
	void get_frame(blk_t &Y, blk_t &Cr, blk_t &Cb, STATS &mpstat);
  void set_file_pattern(char *name);

	private:
	int hrz_size;
	int vert_size;
	ifstream Yin;
	ifstream Cbin;
	ifstream Crin;
	int frame_count;
	char *file_pattern;

};

class OBUFF
{
	public:
	OBUFF();
	OBUFF(char *filename);
	~OBUFF();
	void put_bits(int value, BYTE_t size);
	void byte_allign(void);

	private:
	u32 bytes_written;
	BYTE_t buffer;
	BYTE_t bits_in_buff;

	ofstream fout;

};


















