/***************************************************************************
                          vlc_codes.h  -  description
                             -------------------
    begin                : Wed Jan 5 2000
    copyright            : (C) 2000 by Jeff Anderson
    email                : jbanders@mines.edu
 ***************************************************************************/
// Parts of the vlc code is from the MPEG software simulation group I will replace it soon
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef MPEG2ENC_H
#define MPEG2ENC_H
#include "mpeg2enc.h"
#endif

#include "vlc.h"

typedef struct
{
	u16 vlcode;
	BYTE_t length;
} VLCtable_t;

// table B.1 Vairable length codes for macroblock_address_increment
static VLCtable_t macroblock_address_increment[34] =
{
						// Increment value
	{0x00,0},	// just used as a place holder
	{0x01,1},	// 1
	{0x03,3},	// 2
	{0x02,3},	// 3
	{0x03,4}, // 4
	{0x02,4}, // 5
	{0x03,5}, // 6
	{0x02,5}, // 7
	{0x07,7}, // 8
	{0x06,7}, // 9
	{0x0b,8}, // 10
	{0x0a,8}, // 11
	{0x09,8}, // 12
	{0x08,8}, // 13
	{0x07,8}, // 14
	{0x06,8}, // 15
	{23 ,10},	// 16
	{22, 10},	// 17
	{21, 10},	// 18
	{20, 10}, // 19
	{19, 10}, // 20
	{18, 10}, // 21
	{35, 11},	// 22
	{34, 11}, // 23
	{33, 11}, // 24
	{32, 11},	// 25
	{31, 11}, // 26
	{30, 11}, // 27
	{29, 11}, // 28
	{28, 11}, // 29
	{27, 11}, // 30
	{26, 11}, // 31
	{25, 11}, // 32
	{24, 11}	// 33
};

// table B.2 Variable length codes for macroblock_type in I-pictures
static VLCtable_t mblock_type[2][2] =
{
	// I-frame
	{
		{1,1},		// Intra	
		{1,2},		// Intra, Quant
	},
	// P-frame
	// FIXME when I add support for P frames
	{
		{0,0},
		{0,0},
	}
};

// table B.12 Variable length codes for dct_dc_size_luminance
static VLCtable_t dct_dc_size_luminance[12] =
{
	//VLC	//size	//dct_dc_size_luminance
	{4,3},				// 0
	{0,2},				// 1
	{1,2},				// 2
	{5,3},				// 3
	{6,3},				// 4
	{14,4},				// 5
	{30,5},				// 6
	{62,6},				// 7
	{126,7},			// 8
	{254,8},			// 9
	{510,9},			// 10
	{511,9}				// 11
};

// table B.13 Variable length codes for dct_dc_size_chrominance
static VLCtable_t dct_dc_size_chrominance[12] =
{
	//VLC	//size	//dct_dc_size_chrominance
	{0,2},				// 0
	{1,2},				// 1
	{2,2},				// 2
	{6,3},				// 3
	{14,4},				// 4
	{30,5},				// 5
	{62,6},				// 6
	{126,7},			// 7
	{254,8},			// 8
	{510,9},			// 9
	{1022,10},		// 10
	{1023,10}			// 11
};

// table B.14 DCT coefficients Table zero
static VLCtable_t dct_coeff_zero[2][41] =
{
 /* run = 0, level = 1...40 */
 {
  {0x03, 2}, {0x04, 4}, {0x05, 5}, {0x06, 7},
  {0x26, 8}, {0x21, 8}, {0x0a,10}, {0x1d,12},
  {0x18,12}, {0x13,12}, {0x10,12}, {0x1a,13},
  {0x19,13}, {0x18,13}, {0x17,13}, {0x1f,14},
  {0x1e,14}, {0x1d,14}, {0x1c,14}, {0x1b,14},
  {0x1a,14}, {0x19,14}, {0x18,14}, {0x17,14},
  {0x16,14}, {0x15,14}, {0x14,14}, {0x13,14},
  {0x12,14}, {0x11,14}, {0x10,14}, {0x18,15},
  {0x17,15}, {0x16,15}, {0x15,15}, {0x14,15},
  {0x13,15}, {0x12,15}, {0x11,15}, {0x10,15}
 },
 /* run = 1, level = 1...18 */
 {
  {0x03, 3}, {0x06, 6}, {0x25, 8}, {0x0c,10},
  {0x1b,12}, {0x16,13}, {0x15,13}, {0x1f,15},
  {0x1e,15}, {0x1d,15}, {0x1c,15}, {0x1b,15},
  {0x1a,15}, {0x19,15}, {0x13,16}, {0x12,16},
  {0x11,16}, {0x10,16}, {0x00, 0}, {0x00, 0},
  {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0},
  {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0},
  {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0},
  {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0},
  {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}
 }
};
/*
{
	{	//run = 0 level =
		{0,0}, // 0 used as place holder
		{3,2}, // 1
		{4,4}, // 2
		{5,5}, // 3
		{6,7}, // 4
		{38,8}, // 5
		{33,8}, // 6
		{10,10}, // 7
		{29,12}, // 8
		{24,12}, // 9
		{19,12}, // 10
		{16,12}, // 11
		{26,13}, // 12
		{25,13}, // 13
		{24,13}, // 14
		{23,13}, // 15
		{31,14}, // 16
		{30,14}, // 17
		{29,14}, // 18
		{28,14}, // 19
		{27,14}, // 20
		{26,14}, // 21
		{25,14}, // 22
		{24,14}, // 23
		{23,14}, // 24
		{22,14}, // 25
		{21,14}, // 26
		{20,14}, // 27
		{19,14}, // 28
		{18,14}, // 29
		{17,14}, // 30
		{16,14}, // 31
		{24,15}, // 32
		{23,15}, // 33
		{22,15}, // 34
		{21,15}, // 35
		{20,15}, // 36
		{19,15}, // 37
		{18,15}, // 38
		{17,15}, // 39
		{16,15} // 40
	},	//end run = 0

	{	//run = 1 level =
		{0,0}, // 0 place holder
		{3,3}, // 1
		{6,6}, // 2
		{37,8}, // 3
		{12,10}, // 4
		{27,12}, // 5
		{22,13}, // 6
		{21,13}, // 7
		{31,15}, // 8
		{30,15}, // 9
		{29,15}, // 10
		{28,15}, // 11
		{27,15}, // 12
		{26,15}, // 13
		{25,15}, // 14
		{19,16}, // 15
		{18,16}, // 16
		{17,16}, // 17
		{16,16}  // 18
	}	// end run = 1
};
*/
static VLCtable_t dct_coeff_zero2[30][5]=
{
  /* run = 2...31, level = 1...5 */
  {{0x05, 4}, {0x04, 7}, {0x0b,10}, {0x14,12}, {0x14,13}},
  {{0x07, 5}, {0x24, 8}, {0x1c,12}, {0x13,13}, {0x00, 0}},
  {{0x06, 5}, {0x0f,10}, {0x12,12}, {0x00, 0}, {0x00, 0}},
  {{0x07, 6}, {0x09,10}, {0x12,13}, {0x00, 0}, {0x00, 0}},
  {{0x05, 6}, {0x1e,12}, {0x14,16}, {0x00, 0}, {0x00, 0}},
  {{0x04, 6}, {0x15,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x07, 7}, {0x11,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x05, 7}, {0x11,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x27, 8}, {0x10,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x23, 8}, {0x1a,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x22, 8}, {0x19,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x20, 8}, {0x18,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x0e,10}, {0x17,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x0d,10}, {0x16,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x08,10}, {0x15,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1f,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1a,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x19,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x17,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x16,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1f,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1e,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1d,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1c,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1b,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1f,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1e,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1d,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1c,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1b,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}}
};

/* Table B-15, DCT coefficients table one
 *
 * indexed by [run][level-1]
 * split into two tables (dct_code_tab1a, dct_code_tab2a) to reduce size
 * 'End of Block' is treated elsewhere
 * codes do not include s (sign bit)
 */

static VLCtable_t dct_code_tab1a[2][40]=
{
 /* run = 0, level = 1...40 */
 {
  {0x02, 2}, {0x06, 3}, {0x07, 4}, {0x1c, 5},
  {0x1d, 5}, {0x05, 6}, {0x04, 6}, {0x7b, 7},
  {0x7c, 7}, {0x23, 8}, {0x22, 8}, {0xfa, 8},
  {0xfb, 8}, {0xfe, 8}, {0xff, 8}, {0x1f,14},
  {0x1e,14}, {0x1d,14}, {0x1c,14}, {0x1b,14},
  {0x1a,14}, {0x19,14}, {0x18,14}, {0x17,14},
  {0x16,14}, {0x15,14}, {0x14,14}, {0x13,14},
  {0x12,14}, {0x11,14}, {0x10,14}, {0x18,15},
  {0x17,15}, {0x16,15}, {0x15,15}, {0x14,15},
  {0x13,15}, {0x12,15}, {0x11,15}, {0x10,15}
 },
 /* run = 1, level = 1...18 */
 {
  {0x02, 3}, {0x06, 5}, {0x79, 7}, {0x27, 8},
  {0x20, 8}, {0x16,13}, {0x15,13}, {0x1f,15},
  {0x1e,15}, {0x1d,15}, {0x1c,15}, {0x1b,15},
  {0x1a,15}, {0x19,15}, {0x13,16}, {0x12,16},
  {0x11,16}, {0x10,16}, {0x00, 0}, {0x00, 0},
  {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0},
  {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0},
  {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0},
  {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0},
  {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}
 }
};

static VLCtable_t dct_code_tab2a[30][5]=
{
  /* run = 2...31, level = 1...5 */
  {{0x05, 5}, {0x07, 7}, {0xfc, 8}, {0x0c,10}, {0x14,13}},
  {{0x07, 5}, {0x26, 8}, {0x1c,12}, {0x13,13}, {0x00, 0}},
  {{0x06, 6}, {0xfd, 8}, {0x12,12}, {0x00, 0}, {0x00, 0}},
  {{0x07, 6}, {0x04, 9}, {0x12,13}, {0x00, 0}, {0x00, 0}},
  {{0x06, 7}, {0x1e,12}, {0x14,16}, {0x00, 0}, {0x00, 0}},
  {{0x04, 7}, {0x15,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x05, 7}, {0x11,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x78, 7}, {0x11,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x7a, 7}, {0x10,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x21, 8}, {0x1a,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x25, 8}, {0x19,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x24, 8}, {0x18,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x05, 9}, {0x17,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x07, 9}, {0x16,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x0d,10}, {0x15,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1f,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1a,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x19,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x17,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x16,12}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1f,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1e,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1d,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1c,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1b,13}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1f,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1e,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1d,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1c,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}},
  {{0x1b,16}, {0x00, 0}, {0x00, 0}, {0x00, 0}, {0x00, 0}}
};
