/*****
*
* This file is part of the OMS program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#ifndef __XMLPARSE_H__
#define __XMLPARSE_H__

#include <inttypes.h>
#include <gnome-xml/parser.h>

typedef struct xml_tree_struct {
	void *data;
	struct xml_tree_struct *prev;
	struct xml_tree_struct *next;	
} oms_xmltree_t;

typedef void (*xmlptr_t)(xmlDocPtr doc, xmlNodePtr cur);

typedef struct _oms_node {
        unsigned int type_val;
        const char *type_name;

        const char *var_val;
        const char *var_name;
        const char *text;

        struct _oms_node *next;
        struct _oms_node *prev;
} oms_xmltree_node_t;

typedef struct {
	const char *name;
        const unsigned int type;
} oms_xmltag_tbl_t;

typedef struct {
        const char *name;
        xmlptr_t handler;
} xmlhandler_tbl_t;

int oms_xml_init (xmlhandler_tbl_t *_xmlhandler_tbl);
oms_xmltree_t *oms_xml_parse_file (const char *file);
oms_xmltree_t *oms_xml_list_add (void *data);

#endif
