/*****
*
* This file is part of the OMS program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#include <stdio.h>
#include <dlfcn.h>

#include <glib.h>
#include "xmms_plugin.h"
#include "xmms_configfile.h"

//#define PLUGIN_NAME	"./libsanalyzer.so"
#define PLUGIN_NAME	"./gdancer.so"
//#define PLUGIN_NAME	"./libbscope.so"

char filename[] = PLUGIN_NAME;

ConfigFile *xmms_cfg_open_file (gchar *name);

ConfigFile *xmms_cfg_open_file (gchar *name)
{
	fprintf (stderr, "xmms_cfg_open_file\n");
	return NULL;
}

int main (void)
{
	void *handle = dlopen (filename, RTLD_LAZY);
	void *(*sym)(void) = dlsym (handle, "get_vplugin_info");
	VisPlugin *plugin = (*sym) ();

	fprintf (stderr, "description: %s\n", plugin->description);

	plugin->handle = handle;
	plugin->filename = filename;

	plugin->init ();
	plugin->configure ();
	plugin->about ();
	plugin->cleanup ();
//	return dlclose (handle);
	gtk_main ();

	while (1);
	return 0;
}
