#!/usr/bin/perl

my $in_cpp = 0;
my $in_comment = 0;

sub handle_comments
{
	if ($in_comment == 1) {			# already in comment
		if (/\*\//) {			# end of comment
			$in_comment = 0;
		}
		return "";
	} elsif (/\/\*\s/) {			# normal comment -> skip
		$in_comment = 1;
	} else {
		return $_;
	}

	return "";
}

%defines = { BYTEORDER => 'BIG_ENDIAN' };

sub handle_cpp
{
	if (/\#/) {
		return "";
	}
	return $_;

#############
	if (/\#(.*)/) {
		$_ = $1;

		if (/endif/) {
			$in_cpp --;
			if ($in_cpp < 0) {
				$in_cpp = 0;
			}
		} elsif (/ifndef(.*)/) {
			if (defined $defines[$1]) {
				$in_cpp ++;
			}
		} elsif (/if\s*(.*)/) {
			($var, $op, $val) = split (' ', $1);
			if ($op) {
				if (!eval $var.$op.$val) {
					$in_cpp ++;
				}
			} elsif ($defined[$var] == 0) {
				$in_cpp ++;
			}
		}

		return "";
	}

	if ($in_cpp > 0) {
		return "";
	}

	return $_;
}

sub output_entry
{
	($var_name, $var_bits) = @_;

	print "\t\t<row>";
#	print "<entry><structfield>$var_name</structfield></entry>";
	print "<entry><screen>$var_name</screen></entry>";
	print "<entry>$var_bits</entry>";
	print "</row>\n";
}

sub process_file
{
	($filename) = @_;
	open (FD, "<$filename");

	foreach (<FD>) {
		my @line;

# toss normal comments
		$_ = handle_comments ($_);
		$_ = handle_cpp ($_);

		s/\t/\ \ \ \ \ \ \ \ /g;

# <handle 'useful' comments>
		if (/\/\/\//) {	# comment to parse
			$_ = $';
			($line, $bits) = split (':');
			$bits =~ s/\;//;
			output_entry ($line, $bits);
			next;
		}
# </handle 'useful' comments>

		if (/^\s*{/ || /^\s*}/ || /\s*struct/ || /^\s*typedef/) {
			next;
		}

		($line, $bits) = split (':');
		$bits =~ s/\;//;

		/^(\ *).*/;
		$spaces = $1;
		@line = split (' ', $line);
		$varname = $spaces.$line[$#line];

		if ($#line < 1) {	# we need var_type+ var_name
			if ($bits == "") {
				next;
			}
			$varname = "reserved";
		}
	
		if ($_) {
			output_entry ($varname, $bits);
		}
	}

	close (FD);
}

print "<table frame=all tocentry=\"1\">";
print "<title>TITLE COMES HERE</title>";
print "<tgroup cols=2 align=left>\n";
print "<thead><row><entry>Syntax</entry><entry>No. of bits</entry></row></thead>\n";
print "<tbody>";
process_file (shift);
print "</tbody></tgroup></table>";
exit;

