/*****
*
* This file is part of the OMS program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

#include <oms/plugin.h>

#error FIXME - plugin-loading doesn't work like that !!

extern plugin_decaps_t *plugin_init (void *foo);

int fd;

int foo_read (buf_t * buf, buf_entry_t * buf_entry)
{
	return (int) read (fd, (void *) buf_entry->mem,
			   (size_t) buf_entry->mem_len);
}

int foo_write (buf_t * buf, buf_entry_t * buf_entry)
{
	write (1, buf_entry->mem, buf_entry->mem_len);
	free (buf_entry->mem);

	return 0;
}

int main (int argc, char *argv[])
{
	plugin_decaps_t *decaps;
	buf_t buf;

	if (argc < 2) {
		fprintf (stderr, "usage %s <filename>\n", argv[0]);
		exit (-1);
	}

	decaps = plugin_init (NULL);
	decaps->read = foo_read;
	decaps->write = foo_write;
	decaps->blocksize = 2256;

	fd = open (argv[1], O_RDONLY);

	while (1) {
		decaps->decaps (&buf);
	}

	plugin_exit ();
	close (fd);

	return 0;
}
