/*****
*
* This file is part of the OMS program.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

/*
 * video_out.c
 * Copyright (C) 1999-2000 Aaron Holtzman <aholtzma@ess.engr.uvic.ca>
 *
 * This file is part of mpeg2dec, a free MPEG-2 video stream decoder.
 *
 * mpeg2dec is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * mpeg2dec is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "config.h"

#include <stdlib.h>
#include <inttypes.h>

#ifdef __OMS__
#include <oms/plugin/output_video.h>
#else
#include "video_out.h"
#endif

//
// Externally visible list of all vo drivers
//

extern plugin_output_video_t video_out_x11;
extern plugin_output_video_t video_out_sdl;
extern plugin_output_video_t video_out_mga;
extern plugin_output_video_t video_out_3dfx;
extern plugin_output_video_t video_out_syncfb;
extern plugin_output_video_t video_out_null;
extern plugin_output_video_t video_out_pgm;
extern plugin_output_video_t video_out_md5;

plugin_output_video_t* video_out_drivers[] = 
{
#ifdef LIBVO_X11
	&video_out_x11,
#endif
#ifdef LIBVO_SDL
	&video_out_sdl,
#endif
#ifdef LIBVO_MGA
	&video_out_mga,
#endif
#ifdef LIBVO_3DFX
	&video_out_3dfx,
#endif
#ifdef LIBVO_SYNCFB
	&video_out_syncfb,
#endif
	&video_out_null,
	&video_out_pgm,
	&video_out_md5,
	NULL
};
